// WaveFormats.h: extra WAVEFORMAT definitions, etc.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_WAVEFORMATS_H__963A2A54_7AFE_4DE9_BF2A_1E79F911E37B__INCLUDED_
#define AFX_WAVEFORMATS_H__963A2A54_7AFE_4DE9_BF2A_1E79F911E37B__INCLUDED_

#include <windows.h>
#include <mmreg.h>
#include <mmsystem.h>

enum WaveFormats
{
	WaveFormat_ULaw			= 0,
	WaveFormat_ALaw			= 1,
	WaveFormat_G729			= 2,
	WaveFormat_G723_53		= 3,
	WaveFormat_G723_63		= 4,
	WaveFormat_PCM_16_8_1	= 5
};

#define WAVE_FORMAT_CISCO_G729			0xFE01
#define WAVE_FORMAT_CISCO_G723_53		0xFE02
#define WAVE_FORMAT_CISCO_G723_63		0xFE03

class Tracer;

class WaveFormat  
{
public:
	static WAVEFORMATEX GetWaveFormat(int nWaveFormat);
	static void TraceFormat(Tracer *tracer, unsigned long traceLevel, WAVEFORMATEX &wfx);
private:
	WaveFormat();
	virtual ~WaveFormat();

};

#endif	// AFX_WAVEFORMATS_H__963A2A54_7AFE_4DE9_BF2A_1E79F911E37B__INCLUDED_
